/*
 * This file is part of faultd.
 *
 * Copyright © 2017 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef FAULTD_CONFIG_H
#define FAULTD_CONFIG_H

#include <ejdb/ejdb.h>

struct faultd_config {
	struct json_object *root;
};

int faultd_parse_config(const char *config_path, struct faultd_config *c);
void faultd_config_cleanup(struct faultd_config *c);
int faultd_config_get_subconf(struct faultd_config *conf, const char *key, struct faultd_config **sub);

#endif /* FAULTD_CONFIG_H */
