#include <stddef.h>
#include <setjmp.h>
#include <stdarg.h>
#include <cmocka.h>

#include "fdtf.h"
#include "module.h"

static struct list_head test_groups = LIST_HEAD_INIT(test_groups);

void fdtf_register_test_group(struct fdtf_test_group *tg)
{
	list_add_tail(&tg->node, &test_groups);
}

int fdtf_run_test_group(struct fdtf_test_group *tg)
{
	return _cmocka_run_group_tests(tg->name,
								   tg->tests,
								   tg->number_of_tests,
								   tg->setup,
								   tg->teardown);
}

int fdtf_run_all_test_groups()
{
	struct fdtf_test_group *tg;
	int ret = 0;
	int fail = 0;

	list_for_each_entry(tg, &test_groups, node)
		if((ret = fdtf_run_test_group(tg)) != 0)
			fail = ret;

	if (fail != 0)
		return fail;

	return 0;
}

int main(int argc, char **argv)
{
	/*
	 * TODO:
	 * Add here some more logic to allow to run
	 * only subset of tests
	 */
	return fdtf_run_all_test_groups();
}
